function jsonToString(obj){  
    var THIS = this;   
    switch(typeof(obj)){  
        case 'string':  
            //return '"' + obj.replace(/(["\\])/g, '\\$1') + '"'; 
            //return '"' + escape(obj) + '"'; 
            return '"' + obj + '"'; 
        case 'array':  
            return '[' + obj.map(THIS.jsonToString).join(',') + ']';  
        case 'object':  
            if(obj instanceof Array){  
                var strArr = [];  
                var len = obj.length;  
                for(var i=0; i<len; i++){  
                    strArr.push(THIS.jsonToString(obj[i]));  
                }  
                return '[' + strArr.join(',') + ']';  
             }else if(obj==null){  
                return 'null';  
             }else{  
                var string = [];  
                for (var property in obj) string.push(THIS.jsonToString(property) + ':' + THIS.jsonToString(obj[property]));  
                return '{' + string.join(',') + '}';  
             }  
         case 'number':  
                return obj;  
         case false:  
                return obj;  
     }  
}

MXScriptObject = function(){
			    
			    function getCallbackId(fun) {
			        var callbackId = 'native_callback-'+ (++ MXScriptObject.callId);
			        MXScriptObject.native_callbacks[callbackId] = fun;
			        return callbackId;
			    }
			    return {
			    native_callbacks:[],
			    callId:0,
			    calls:[],
			    
			    callNativeMethodWithCallback: function(selName, callbackFun) {
			        //var currCallId = 'jsCall-'+ (++ MXScriptObject.callId);
			      // alert(jsonToString(Array.prototype.slice.call(arguments, 2)));
			       window.MXJSObject.jsCall('{"callbackId": ' + jsonToString(getCallbackId(callbackFun)) + ',"sel": '+ jsonToString(selName) +', "args": ' + jsonToString(Array.prototype.slice.call(arguments, 2)) + '}');
			    },
			    
			    callNativeMethod:function(selName){
			    	window.MXJSObject.jsCall('"sel": '+ jsonToString(selName));
			    },
			
			    nativeCallback: function (callbackId, retObj) {
			        console.log('dump1:'+ callbackId+","+retObj+'typeof retObj:'+(typeof retObj));
			        var args = null;
			        try{
			        	args = retObj;//eval('('+retObj+')');
			        }catch(e){
			        	console.log('exception:'+e);
			        }
			        console.log('dump2:'+args+","+args.status);
			        if (MXScriptObject.native_callbacks[callbackId]) {
			        
			            // If result is to be sent to callback
			            try {
			                if (MXScriptObject.native_callbacks[callbackId]) {
			                    MXScriptObject.native_callbacks[callbackId](args.status, args.userInfo);
			                }
			            }
			            catch (e) {
			                console.log('Error in callback: '+callbackId+' = '+e);
			            }
			        
			            // Clear callback if not expecting any more results
			            if (!args.keepCallback) {
			                delete MXScriptObject.native_callbacks[callbackId];
			            }
			        }
			    }
			};}();